HiC_Prepare_Matrix <-
function(file,verbose=TRUE,sep="\t",header=TRUE){
if (!file.exists(file))
{print("No file found in current directory"); return(NULL);}
Data=read.table(file,sep=sep,header=header)
if (dim(Data)[2]<4)
{print("Error. One row must include 4 columns.");return(NULL);}
if (dim(Data)[2]>4){
Data=Data[,1:4];
}

# make the data as the matrix (upper trangle input).
if (verbose)
{print(paste(dim(Data)[1],"observations are loaded...",sep=" ") )}

# filling the data in the matrix
if (verbose)
{print("Preparing the matrix of expected count and observed count...")}

fragIDs=unique(sort(c(Data[,1],Data[,2])))
size=length(fragIDs)
ExpectedCountMatrix=array(NA,dim=c(size,size))
ObservedCountMatrix=array(NA,dim=c(size,size))
rownames(ExpectedCountMatrix)=fragIDs
colnames(ExpectedCountMatrix)=fragIDs
rownames(ObservedCountMatrix)=fragIDs
colnames(ObservedCountMatrix)=fragIDs
for (i in 1:dim(Data)[1]){
ExpectedCountMatrix[as.character(Data[i,1]),as.character(Data[i,2])]=Data[i,4]
ObservedCountMatrix[as.character(Data[i,1]),as.character(Data[i,2])]=Data[i,3]
}
return(list(ExpectedCountMatrix=ExpectedCountMatrix,ObservedCountMatrix=ObservedCountMatrix,fragIDs=fragIDs))
}
